<form [formGroup]="form" (submit)="submit()" fxLayout="column" fxLayoutGap="1rem">

  <div fxLayout="row" fxLayoutAlign="space-between end">
    <div fxLayout="row" fxLayoutGap="1rem">
      <div *ngIf="edition">
        <button mat-raised-button color="warn"
                [routerLink]="['/administration', 'book', 'edition']">
          <mat-label>
            <fa-icon [icon]="['fas', 'arrow-left']" style="padding-right: 10px"></fa-icon>
            {{ 'BOOK.FORM.ACTION.RETURN' | translate }}
          </mat-label>
        </button>
      </div>
      <h2>
        <app-title-display
          [isbn]="book?.isbn" [series]="getSeries()"
          [title]="form.value.title">
        </app-title-display>
      </h2>
    </div>
    <div [formGroup]="series" fxLayout="column">
      <div fxLayoutAlign="end center" fxLayout="row" fxLayoutGap="1rem">
        <span *ngIf="!edition">
          {{ 'BOOK.FORM.ADD_TO' | translate }}
        </span>
        <mat-form-field *ngIf="!edition" appearance="outline" subscriptSizing="dynamic">
          <mat-select [(value)]="selectedTarget">
            <mat-option [value]="'LIBRARY'">{{ 'BOOK.FORM.ADD.TARGET.LIBRARY' | translate }}</mat-option>
            <mat-option [value]="'WISHLIST'">{{ 'BOOK.FORM.ADD.TARGET.WISHLIST' | translate }}</mat-option>
          </mat-select>
        </mat-form-field>
        <button mat-raised-button color="primary" [disabled]="form.invalid">
          <mat-label>{{ 'BOOK.FORM.ACTION.' + translateCategory | translate }}</mat-label>
        </button>
      </div>
      <app-book-type-form [form]="getBookTypeFormGroup()"></app-book-type-form>
    </div>
  </div>
  <div fxLayout="row">
    <div fxFlex="35" fxLayout="column" fxLayoutGap="1rem" fxLayoutAlign="start center" style="height: inherit">
      <ngx-dropzone class="dropzone" fxLayout="column" fxLayoutAlign="center center" (change)="onSelect($event)">
        <div class="cover-wrapper">
          <app-loader-img
            *ngIf="!uploadCover"
            [img]="(cover$ | async)">
          </app-loader-img>
        </div>
      </ngx-dropzone>
      <div fxLayout="row" fxLayoutGap="2rem" fxLayoutAlign="center center">
        <a [href]="'https://www.google.com/search?tbm=isch&q='+book.isbn"
           target="_blank" mat-button mat-stroked-button>
          <!--          TODO use translation-->
          Search on Google images
        </a>
      </div>
    </div>
    <div fxFlex fxLayout="column">
      <div fxLayout="row" fxLayoutGap="2rem">
        <div fxLayout="column" fxFlex="45" fxLayoutGap="2rem">
          <div fxLayout="column">
            <h3>{{ 'BOOK.FORM.SECTION_TITLE.GLOBAL_INFORMATION' | translate }}</h3>
            <!-- Title - Series - Tome-->
            <div fxLayout="column">
              <mat-slide-toggle
                [disabled]="edition"
                [checked]="book.series.oneShot"
                (change)="switchToOneShot($event)"
                labelPosition="before" fxFlexAlign="end">
                {{ 'SERIES.ONE_SHOT' | translate }}
              </mat-slide-toggle>
              <div fxLayout="row" fxLayoutGap="1rem">
                <mat-form-field fxFlex="25" [formGroup]="series" appearance="outline"
                                class="mff-space-1"
                                subscriptSizing="dynamic">
                  <label>
                    <input matInput type="number" min="0"
                           [placeholder]="'BOOK.FORM.TOME' | translate"
                           formControlName="tome"/>
                  </label>
                </mat-form-field>
                <mat-form-field fxFlex appearance="outline" subscriptSizing="dynamic"
                                class="mff-space-1">
                  <mat-label> {{ 'BOOK.FORM.TITLE' | translate }}</mat-label>
                  <input matInput formControlName="title"/>
                  <mat-error
                    *ngIf="form.get('title').hasError('required')">{{ 'BOOK.FORM.ERRORS.REQUIRED' | translate }}
                  </mat-error>
                </mat-form-field>
                <mat-form-field fxFlex="25" appearance="outline" subscriptSizing="dynamic"
                                class="mff-space-1">
                  <label>
                    <input id="bookYearInput" matInput [placeholder]="'BOOK.FORM.YEAR' | translate"
                           formControlName="year"
                           [value]="book.year"/>
                    {{ 'BOOK.FORM.YEAR' | translate }}
                  </label>
                </mat-form-field>
              </div>
              <mat-form-field appearance="outline" subscriptSizing="dynamic"
                              class="mff-space-1">
                <label>
                  <input id="bookCollectionInput" matInput [placeholder]="'BOOK.FORM.COLLECTION' | translate"
                         formControlName="collection"
                         [value]="book.collection"/>
                  {{ 'BOOK.FORM.COLLECTION' | translate }}
                </label>
              </mat-form-field>
            </div>
          </div>
          <div fxLayout="column">
            <h3>{{ 'BOOK.FORM.SECTION_TITLE.SERIES' | translate }}</h3>
            <app-series-form
              [edition]="edition" fxFlex [form]="series"
              (selection)="onSeriesSelection($event)"></app-series-form>
          </div>
          <div fxLayout="column">
            <h3>{{ 'BOOK.FORM.SECTION_TITLE.EDITOR' | translate }}</h3>
            <app-editor-form fxFlex [form]="editor"
                             (selection)="onEditorSelection($event)"></app-editor-form>
          </div>
        </div>
        <mat-tab-group fxFlex="100" *ngIf="!targetIsWishList()">
          <mat-tab style="min-width: 100%">
            <ng-template mat-tab-label>
              <h3>{{ 'BOOK.FORM.SECTION_TITLE.ARTISTS' | translate }}</h3>
            </ng-template>
            <div fxLayout="column" fxFlex="100" style="margin-top: 1rem">
              <app-role-form (addContract)="addContract($event)"></app-role-form>
              <app-contract-form
                style="margin-top: 1rem"
                *ngFor="let contract of getFormContractsFromGroups(); let i = index"
                [index]="i"
                [form]="contract"
                (actionArtist)="onActionArtist($event, i)"
                (delete)="deleteContract($event)"
              ></app-contract-form>
            </div>
          </mat-tab>
          <mat-tab style="min-width: 100%">
            <ng-template mat-tab-label>
              <h3>{{ 'BOOK.FORM.SECTION_TITLE.METADATA' | translate }}</h3>
            </ng-template>
            <div fxLayout="column" fxFlex="100" style="margin-top: 1rem">
              <app-book-metadata-form
                [form]="metadata"
                (updateOfferedStatus)="onUpdateOfferedStatus($event)"></app-book-metadata-form>
            </div>
          </mat-tab>
        </mat-tab-group>
      </div>
    </div>
  </div>
</form>
